# -*- coding:Utf-8 -*-
import es, gamethread, playerlib, langlib, popuplib

def load():
	global joueurs, commandes, messages
	info = es.AddonInfo()
	info.name = 'zm_invisible'
	info.version = '1.2'
	info.author = 'Phoval'
	info.url = 'http://mattie.info/forums/'
	info.description = 'Invisible for zombie !'
	info.tags = 'zombie;invisible'
	es.ServerVar('zm_invisible_version', info.version, 'zm_invisible: Version of the zm_invisible script').makepublic()
	es.ServerVar('zmi_commandes', '!inv,!invisible', 'zm_invisible: Say commands for a zombie is invisible')
	es.ServerVar('zmi_temps', '7', 'zm_invisible: Time when a zombie is invisible in seconds')
	es.ServerVar('zmi_nbrfois', '5', 'zm_invisible: Number of times a zombie perhaps invisible')
	es.ServerVar('zmi_visible', '0', 'zm_invisible: Rate visibility of the zombie 0 = invisible, 255 = fully visible')
	es.mexec('zm_invisible/config.cfg')
	messages = langlib.Strings(es.getAddonPath('zm_invisible')+'/../../../cfg/zm_invisible/translations.ini')
	commandes = str(es.ServerVar('zmi_commandes')).split(',') 
	joueurs = {}
	listejoueurs = es.getUseridList()
	for index in commandes:
		es.regsaycmd(index, 'zm_invisible/invisible', 'Invisibilit')
	for index in listejoueurs:
		joueurs[str(index)] = { 'now' : 0, 'fois' : 0 }

def unload():
	global joueurs, commandes, messages
	for index in commandes:
		es.unregsaycmd(index)
	del joueurs
	del commandes
	del messages

def round_start(event_var):
	global joueurs
	for userid in joueurs:
		joueurs[userid] = { 'now' : 0, 'fois' : 0 }

def player_connect(event_var):
	global joueurs
	joueurs[event_var['userid']] = { 'now' : 0, 'fois' : 0 }

def player_disconnect(event_var):
	global joueurs
	del joueurs[event_var['userid']]

def invisible():
	global joueurs, messages
	userid = str(es.getcmduserid())
	joueur = playerlib.getPlayer(userid)
	if joueur.attributes['teamid'] == 2 and joueur.attributes['isdead'] == 0 and joueurs[userid]['now'] == 0 and joueurs[userid]['fois'] < int(es.ServerVar('zmi_nbrfois')):
		joueurs[userid]['now'] = 1
		joueurs[userid]['fois'] += 1
		tokens = { 'temps' : int(es.ServerVar('zmi_temps')), 'pfois' : joueurs[userid]['fois'], 'nbrfois' : int(es.ServerVar('zmi_nbrfois')) }
		menu_inv = popuplib.create('menu_inv')
		menu_inv.addline(messages('invisible', opts = tokens, lang = joueur.get('lang')))
		menu_inv.timeout('view', int(es.ServerVar('zmi_temps')))
		menu_inv.send(userid)
		joueur.set('color', [255, 255, 255, int(es.ServerVar('zmi_visible'))])
		es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
		es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha '+str(es.ServerVar('zmi_visible')))
		gamethread.delayed(int(es.ServerVar('zmi_temps')), visible, userid)

def visible(userid):
	global joueurs
	joueurs[userid]['now'] = 0
	joueur = playerlib.getPlayer(userid)
	joueur.set('color', [255, 255, 255, 255])
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha 255')
